/* Events: Sample, Zero Crossings, Relations, Discrete Changes */
#include "WaterTank_Control_model.h"
#if defined(__cplusplus)
extern "C" {
#endif

/* Initializes the raw time events of the simulation using the now
   calcualted parameters. */
void WaterTank_Control_function_initSample(DATA *data, threadData_t *threadData)
{
  long i=0;
}

const char *WaterTank_Control_zeroCrossingDescription(int i, int **out_EquationIndexes)
{
  static const char *res[] = {"level <= minlevel",
  "level >= maxlevel"};
  static const int occurEqs0[] = {1,7};
  static const int occurEqs1[] = {1,6};
  static const int *occurEqs[] = {occurEqs0,occurEqs1};
  *out_EquationIndexes = (int*) occurEqs[i];
  return res[i];
}

/* forwarded equations */

int WaterTank_Control_function_ZeroCrossingsEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  data->simulationInfo->callStatistics.functionZeroCrossingsEquations++;

  
  TRACE_POP
  return 0;
}

int WaterTank_Control_function_ZeroCrossings(DATA *data, threadData_t *threadData, double *gout)
{
  TRACE_PUSH
  modelica_boolean tmp0;
  modelica_boolean tmp1;

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_tick(SIM_TIMER_ZC);
#endif
  data->simulationInfo->callStatistics.functionZeroCrossings++;

  tmp0 = LessEqZC(data->localData[0]->realVars[0] /* level variable */, data->simulationInfo->realParameter[1] /* minlevel PARAM */, data->simulationInfo->storedRelations[0]);
  gout[0] = (tmp0) ? 1 : -1;
  tmp1 = GreaterEqZC(data->localData[0]->realVars[0] /* level variable */, data->simulationInfo->realParameter[0] /* maxlevel PARAM */, data->simulationInfo->storedRelations[1]);
  gout[1] = (tmp1) ? 1 : -1;

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_accumulate(SIM_TIMER_ZC);
#endif

  TRACE_POP
  return 0;
}

const char *WaterTank_Control_relationDescription(int i)
{
  const char *res[] = {"level <= minlevel",
  "level >= maxlevel"};
  return res[i];
}

int WaterTank_Control_function_updateRelations(DATA *data, threadData_t *threadData, int evalforZeroCross)
{
  TRACE_PUSH
  modelica_boolean tmp2;
  modelica_boolean tmp3;
  
  if(evalforZeroCross) {
    tmp2 = LessEqZC(data->localData[0]->realVars[0] /* level variable */, data->simulationInfo->realParameter[1] /* minlevel PARAM */, data->simulationInfo->storedRelations[0]);
    data->simulationInfo->relations[0] = tmp2;
    tmp3 = GreaterEqZC(data->localData[0]->realVars[0] /* level variable */, data->simulationInfo->realParameter[0] /* maxlevel PARAM */, data->simulationInfo->storedRelations[1]);
    data->simulationInfo->relations[1] = tmp3;
  } else {
    data->simulationInfo->relations[0] = (data->localData[0]->realVars[0] /* level variable */ <= data->simulationInfo->realParameter[1] /* minlevel PARAM */);
    data->simulationInfo->relations[1] = (data->localData[0]->realVars[0] /* level variable */ >= data->simulationInfo->realParameter[0] /* maxlevel PARAM */);
  }
  
  TRACE_POP
  return 0;
}

#if defined(__cplusplus)
}
#endif

